<template>
  <!--  <Renderer-->
  <!--    ref="renderer"-->
  <!--    antialias-->
  <!--    resize="window"-->
  <!--    shadow-->
  <!--    :orbit-ctrl="{ enableDamping: true }"-->
  <!--  >-->
  <!--    <Camera :position="{ x: 0, y: 0, z: 10 }" />-->
  <!--    <Scene ref="scene">-->
  <!--      <AmbientLight />-->
  <!--      <DirectionalLight-->
  <!--        ref="directionalLight"-->
  <!--        :intensity="2"-->
  <!--        :position="{ x: -4, y: 4, z: 5 }"-->
  <!--      />-->
  <!--      &lt;!&ndash;      <GltfModel&ndash;&gt;-->
  <!--      &lt;!&ndash;        src="/earth/scene.gltf"&ndash;&gt;-->
  <!--      &lt;!&ndash;        @progress="onProgress"&ndash;&gt;-->
  <!--      &lt;!&ndash;        @error="onError"&ndash;&gt;-->
  <!--      &lt;!&ndash;        @load="onLoad"&ndash;&gt;-->
  <!--      &lt;!&ndash;      />&ndash;&gt;-->
  <!--    </Scene>-->
  <!--  </Renderer>-->
  <div
    id="map"
    style="width: auto; height: 100vh; position: relative; overflow: hidden"
  ></div>
</template>

<script setup lang="ts">
// import {
//   Camera,
//   Renderer,
//   Scene,
//   GltfModel,
//   // AmbientLight,
//   DirectionalLight,
// } from 'troisjs'
import { onMounted } from 'vue'
import * as THREE from 'three'
// import {
//   DirectionalLightHelper,
//   AxesHelper,
//   TextureLoader,
//   Mesh,
//   Raycaster,
// } from 'three'
import { Loader } from '@googlemaps/js-api-loader'
// import { DragControls } from 'three/examples/jsm/controls/DragControls'
import SplineLoader from '@splinetool/loader'
import { ThreeJSOverlayView, latLngToVector3 } from './src'
import { LOADER_OPTIONS, MAP_ID2D, MAP_ID3D } from './src/config'

// const renderer = ref()
// const scene = ref()
// const directionalLight = ref()
//
// const init = () => {
//   scene.value.add(new AxesHelper(40))
// }
// const orbitControl = () => {
//   const orbitCtrl = renderer.value.three.cameraCtrl
//   console.log(orbitCtrl, 'orbitCtrl')
//   orbitCtrl.enablePan = false
//   // orbitCtrl.maxDistance = 6
//   orbitCtrl.minDistance = 1.5
//   // orbitCtrl.maxPolarAngle = Math.PI
//   orbitCtrl.minPolarAngle = Math.PI / 3.5
//   orbitCtrl.maxPolarAngle = Math.PI / 1.5
//   orbitCtrl.screenSpacePanning = true
// }
// const addMapToEarth = () => {
//   const texture = new TextureLoader().load(
//     // 'http://maps.googleapis.com/maps/api/staticmap?center=9.887269,105.513119&zoom=15&size=512x512&maptype=satellite&key=AIzaSyDbFKNP0PF35sv9ROGzdVryTPIDiQcODBA'
//     // 'https://maps.googleapis.com/maps/api/staticmap?center=Brooklyn+Bridge,New+York,NY&zoom=13&size=600x300&maptype=roadmap&key=AIzaSyDbFKNP0PF35sv9ROGzdVryTPIDiQcODBA'
//     '/globe.jpeg'
//   )
//   texture.wrapS = THREE.RepeatWrapping
//   texture.wrapT = THREE.RepeatWrapping
//   texture.repeat.set(1, 1)
//   const geometry = new THREE.SphereGeometry(5, 50, 50)
//   const material = new THREE.MeshPhongMaterial({
//     color: 0xffffff,
//     map: texture,
//     // bumpMap: texture,
//   })
//   const material2 = new THREE.ShaderMaterial({
//     // vertexShader,
//     // fragmentShader,
//     uniforms: {
//       globeTexture: {
//         value: texture,
//       },
//     },
//   })
//   const mesh = new THREE.Mesh(geometry, material)
//   mesh.rotation.x = 0
//   mesh.rotation.y = 0
//   mesh.rotation.y = 0
//   mesh.castShadow = true
//   mesh.receiveShadow = true
//   scene.value.add(mesh)
// }

// ============================================================ THREEJS ============================================================
// const dragControl = ref()
// const mouse = new THREE.Vector2()
// const raycaster = ref(new Raycaster())
// const arrayModel = ref<Array<THREE.Group>>([])
// const onClickObject = (camera:any) => {
//   function intersection(event, callback) {
//     const draggableObjects = dragControl.value.getObjects()
//     mouse.x = (event.clientX / window.innerWidth) * 2 - 1
//     mouse.y = -(event.clientY / window.innerHeight) * 2 + 1
//     raycaster.value.setFromCamera(mouse, camera)
//     const intersections = raycaster.value.intersectObjects(
//       arrayModel.value,
//       true
//     )
//     if (intersections.length > 0) {
//       const object = intersections[0].object
//       draggableObjects.push(object)
//       callback(object)
//     }
//   }
//   function onClick(event: any) {
//     intersection(event, (object) => {
//       console.log(object)
//       // object.material.color.setHex(0x000000)
//       // object.children[0].position.copy(object.position)
//     })
//   }
//   // const idMain = document.getElementById("renderer")
//   window.addEventListener('click', onClick, false)
// }
// const createDragControl = (renderer: any, camera: any) => {
//   dragControl.value = new DragControls(
//     arrayModel.value,
//     camera,
//     renderer.domElement
//   )
//   dragControl.value.transformGroup = true
//   dragControl.value.addEventListener('hoveron', function (event: any) {})
//   dragControl.value.addEventListener('hoveroff', function (event: any) {})
//   dragControl.value.addEventListener('drag', (event: any) => {
//     event.object.position.y = 0
//   })
// }

const loadGLFTModel = (
  url: string,
  position: any,
  title: string,
  scene: any,
  map: google.maps.Map
) => {
  const loader = new SplineLoader()
  loader.load(
    url,
    function (object: any) {
      object.position.copy(latLngToVector3(position))
      const box = new THREE.Box3().setFromObject(object)
      const size = box.getSize(new THREE.Vector3())
      console.log(object, 'object', size)
      object.scale.set(
        0.3130434782608696,
        0.3130434782608696,
        0.3130434782608696
      )
      object.rotation.y = 1.97
      console.log(object, 'object')
      object.children.forEach((e: any) => {
        // e.material.color.setHex(0x000000)
        const changeColor = (color: number) => {
          e.material = new THREE.MeshBasicMaterial({
            color,
            opacity: 0.5,
            transparent: true,
          })
        }
        switch (e.name) {
          // case 'tầng thấp':
          //   changeColor(0x48b6c2)
          //   break
          // case 'tầng 1':
          //   changeColor(0x89b4ff)
          //   break
          // case 'tầng 2':
          //   changeColor(0x9e2fba)
          //   break
          // case 'sàn':
          //   changeColor(0x878787)
          //   break
          // case 'cột':
          //   changeColor(0x404040)
          //   break
          default:
            changeColor(0xa3a3a3)
            break
        }
      })
      scene.add(object)
      createLabel(position, title, map)
    },
    undefined,
    () => {}
  )
}
// ============================================================ MAP ===========================================================
const listInfoWindow = ref<
  Array<{ id: string; infoWindow: google.maps.InfoWindow }>
>([])
const mapTypeSatellite = ref<boolean>(true)
const mapId = ref<string>(MAP_ID2D)

const createLabel = (position: any, title: string, map: google.maps.Map) => {
  const idBtn = 'detail' + Math.random()
  const contentString = `<div style="color: black;font-weight: bold;padding:10px;cursor: pointer" id="${idBtn}">${title}</div>`
  const infoWindow = new google.maps.InfoWindow({
    content: contentString,
    ariaLabel: 'Uluru',
  })
  infoWindow.setOptions({ position })
  infoWindow.addListener('click', function () {
    alert('clicked ')
  })
  infoWindow.open(map)
  listInfoWindow.value.push({ id: idBtn, infoWindow })
  google.maps.event.addListener(infoWindow, 'domready', () => {
    onClickInfoWindow(map)
  })
}
const onClickInfoWindow = (map: google.maps.Map) => {
  listInfoWindow.value.forEach((e) => {
    const domButton = document.getElementById(e.id)
    if (domButton) {
      domButton.addEventListener('click', () => {
        mapTypeSatellite.value = !mapTypeSatellite.value
        map.setMapTypeId(
          mapTypeSatellite.value
            ? google.maps.MapTypeId.SATELLITE
            : google.maps.MapTypeId.ROADMAP
        )
      })
    }
  })
}
const getCoordinateWithMouse = (map: google.maps.Map) => {
  google.maps.event.addListener(map, 'click', function (event: any) {
    let lat = event.latLng.lat()
    lat = lat.toFixed(4)
    let lng = event.latLng.lng()
    lng = lng.toFixed(4)
    console.log('Latitude: ' + lat + '  Longitude: ' + lng)
  })
}
// const createOverLayMap = (map: google.maps.Map) => {
//   const overlayMap: google.maps.Rectangle = new google.maps.Rectangle()
//   google.maps.event.addListener(map, 'bounds_changed', function () {
//     const bounds: google.maps.LatLngBounds = map.getBounds()
//     const aNorth = bounds?.getNorthEast().lat()
//     const aEast = bounds?.getNorthEast().lng()
//     const aSouth = bounds?.getSouthWest().lat()
//     const aWest = bounds?.getSouthWest().lng()
//     overlayMap.setOptions({
//       strokeOpacity: 0.5,
//       fillColor: '#000000',
//       fillOpacity: 0.5,
//       map,
//       bounds: {
//         north: aNorth + 6 * 0.001,
//         south: aSouth - 6 * 0.001,
//         east: aEast + 6 * 0.001,
//         west: aWest - 6 * 0.001,
//       },
//     })
//   })
// }
const addMap = () => {
  const scene = new THREE.Scene()

  const loader = new Loader(LOADER_OPTIONS)
  loader.load().then(() => {
    const mapOptions = {
      center: {
        lng: -2.98671,
        lat: 53.397556,
      },
      mapId: mapId.value,
      mapTypeId: google.maps.MapTypeId.ROADMAP,
      zoom: 14,
      heading: 90,
      minZoom: 16,
      maxZoom: 20,
      tilt: 45,
      mapTypeControl: true,
      mapTypeControlOptions: {
        style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,
        position: google.maps.ControlPosition.TOP_CENTER,
      },
      zoomControl: true,
      zoomControlOptions: {
        position: google.maps.ControlPosition.LEFT_CENTER,
      },
      scaleControl: true,
      streetViewControl: true,
      streetViewControlOptions: {
        position: google.maps.ControlPosition.LEFT_TOP,
      },
      fullscreenControl: true,
    }
    const map = new google.maps.Map(
      document.getElementById('map') as HTMLElement,
      mapOptions
    )
    // createOverLayMap(map)
    // loadGLFTModel('/scene.splinecode', scene, mapOptions)
    // loadGLFTModel('/scene1.splinecode', scene, mapOptions)
    loadGLFTModel(
      '/scene.splinecode',
      {
        lng: -2.98671,
        lat: 53.397556,
      },
      'North Quay',
      scene,
      map
    )
    // loadGLFTModel(
    //   '/scene2.splinecode',
    //   {
    //     lng: -2.988322,
    //     lat: 53.395932,
    //   },
    //   'North Quay 2',
    //   scene,
    //   map
    // )

    getCoordinateWithMouse(map)
    const overlayView = new ThreeJSOverlayView({
      scene,
      map,
      THREE,
    })
    console.log(overlayView, 'overlayView')
    // const camera = overlayView.getCamera()
    // const renderer = overlayView.getRenderer()
    // createDragControl(renderer, camera)
    // onClickObject(camera)
  })
}
onMounted(() => {
  // init()
  // orbitControl()
  // console.log(directionalLight.value, 'directionalLight.value')
  // const directionalLightHelper = new DirectionalLightHelper(
  //   directionalLight.value.light
  // )
  // scene.value.scene.add(directionalLightHelper)
  // addMapToEarth()
  addMap()

  // renderer.value.onBeforeRender(() => {})
})

// const onLoad = (gltf: any) => {
//   gltf.scene.position.y = 10
// }
// const onProgress = () => {}
// const onError = () => {}
</script>

<style>
.gm-ui-hover-effect {
  display: none !important;
}
.gm-style-iw-t {
  bottom: 50px !important;
}
</style>
